﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Public Sub Class_Globals
	Dim serverActions As List
	Dim uuid As String
End Sub

'Creates an XOM document 
'XML - A valid XML string
'
'Determines what control options the server supports
'Example: <code>
'Dim ctrlParser As Ctrl_Parser
'ctrlParser.Initialize(job.GetString, jobId)</code>
Public Sub Initialize(XML As String, serverId As String)
	uuid = serverId
	' Initialise and build XOM document
	Dim XOM As XOMBuilder
	XOM.Initialize("XOM")
	XOM.BuildFromString(XML, "", Null)
End Sub

Private Sub XOM_BuildDone(XOM_Doc As XOMDocument, Tag As Object)
	' Event raised when XOM document completed or failed
	If XOM_Doc.IsInitialized Then
		' Get root node and retrieve control actions
		Dim rootNode As XOMElement = XOM_Doc.RootElement
		GetControlActions(rootNode)
	Else
		Debug.debugLog("XOM_Doc is not initialized: " & LastException) 'DEBUG
	End If
End Sub

Private Sub GetControlActions(parentNode As XOMElement)
	' Get action nodes
	Dim nameSpace As String = "urn:schemas-upnp-org:service-1-0"
	Dim actionListNode As XOMElement = parentNode.GetFirstChildElementByNameAndNamespace("actionList", nameSpace)
	Dim actionNodes As XOMElements = actionListNode.GetChildElementsByNameAndNamespace("action", nameSpace)
	' Add each available action to serverActions list
	Debug.debugLog("##### ACTIONS #####") 'DEBUG
	serverActions.Initialize
	Dim i As Int
	For i = 0 To actionNodes.Size - 1
		Debug.debugLog(actionNodes.GetElement(i).GetFirstChildElementByNameAndNamespace("name", nameSpace).Value) 'DEBUG
		serverActions.Add(actionNodes.GetElement(i).GetFirstChildElementByNameAndNamespace("name", nameSpace).Value)
	Next
	' See if Browse action is available and browse root container
	CallSub2(UPNP, "CheckBrowseAvailability", uuid)
End Sub