﻿Type=StaticCode
Version=3.82
B4A=true
@EndOfDesignText@
Public Sub Process_Globals

End Sub

'Adds a leading forward slash if not already present
'Address - url text
'
'Example: <code>
'CheckLeadingSlash("upnp/event/cds")</code>
'Returns "/upnp/event/cds"
Public Sub CheckLeadingSlash( Address As String) As String
	If Address.StartsWith("/") Then
		Return Address
	Else
		Return "/" & Address
	End If
End Sub

'Scales image to a new width and height
'Original - image file
'Width - required width
'Height - required height
'Filter - antialiasing filter
'
'Example: <code>
'server.iconBitmap=CreateScaledBitmap(Job.GetBitmap, 80dip, 80dip, True)</code>
'Returns a scaled image 80dipx80dip
Public Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int, Filter As Boolean) As Bitmap
   Dim r As Reflector
   Dim b As Bitmap
   Width = Width/2
   Height = Height/2
   b = r.RunStaticMethod("android.graphics.Bitmap", "createScaledBitmap", _
      Array As Object(Original, Width, Height, Filter), _
      Array As String("android.graphics.Bitmap", "java.lang.int", "java.lang.int", "java.lang.boolean"))
   Return b
End Sub