﻿Type=StaticCode
Version=3.82
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Public Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

'Performs a case insensitive search for pattern in text string
'Pattern - A valid regular expression
'Text - String to search
'
'Returns group 1 of ReEx result or "" if not found
'Example: <code>
'Dim uuid As String
'	uuid=Extract("usn:[\s]?([\S]+)", "USN:uuid:156ad7e9-2736-44b8-8628-eec1b836cb1e:MediaServer:1)"</code>
Public Sub Extract( Pattern As String, Text As String) As String
	Dim m As Matcher
	m = Regex.Matcher2(Pattern, Regex.CASE_INSENSITIVE, Text)
	If m.Find = True Then Return m.Group(1)
	' Return an empty string if pattern not found
	Return ""
End Sub

Public Sub ExtractResolution(strRes As String) As Resolution
	Dim i As Int
	Dim x, y As String = ""
	Dim firstNum As Boolean = True
	For i = 0 To strRes.Length - 1
		If firstNum = True Then
			If IsNumber(strRes.CharAt(i)) Then
				x = x & strRes.CharAt(i)
			Else If x <> "" Then
				firstNum = False
			End If		
		Else
			If IsNumber(strRes.CharAt(i)) Then
				y = y & strRes.CharAt(i)
			Else If y <> "" Then
				Exit
			End If	
		End If
	Next
	Dim res As Resolution
	res.Initialize
	res.x = x
	res.y = y
	Debug.debugLog("Resolution=" & strRes & "  ResX=" & x & "  ResY=" & y)
	Return res
End Sub