﻿Type=StaticCode
Version=3.82
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	Type ScrollingLabel (lbl As Label, Canvas As Canvas, Bitmap As Bitmap, _ 
		SrcRect As Rect, DestRect As Rect, InhibitScroll As Boolean, Pause As Boolean)
	Dim Gap As Int = 10dip
End Sub

Sub StartScrolling (lbl As Label, txt As String, chk As Boolean) As ScrollingLabel
	Dim SL As ScrollingLabel
	SL.Initialize
	SL.lbl = lbl
	SL.Canvas.Initialize(lbl)
	Dim txtWidth, txtHeight As Int
	txtWidth = SL.Canvas.MeasureStringWidth(txt, lbl.Typeface, lbl.TextSize)
	txtHeight = SL.Canvas.MeasureStringHeight(txt, lbl.Typeface, lbl.TextSize)
	If chk = True Then
		If txtWidth < lbl.Width Then
			SL.InhibitScroll=True
		Else
			SL.InhibitScroll=False
		End If
	End If
	Dim b As Bitmap
	b.InitializeMutable(txtWidth + lbl.Width + Gap, lbl.height)
	Dim c As Canvas
	c.Initialize2(b)
	c.DrawText(txt, 0dip, b.height/2 + txtHeight/2, lbl.Typeface, lbl.TextSize, lbl.TextColor, "LEFT")
	SL.SrcRect.Initialize(0, 0, lbl.width, lbl.height)
	SL.DestRect.Initialize(0, 0, lbl.width, lbl.height)
	SL.Bitmap = b
	SL.Canvas.DrawBitmap(SL.Bitmap, SL.SrcRect, SL.DestRect)
	SL.lbl.Invalidate
	Return SL
End Sub

Sub TimerTick (Labels As List)
	Dim repeatDelay As Boolean = True

	For i = 0 To Labels.Size - 1
		Dim SL As ScrollingLabel
		SL = Labels.Get(i)
		If SL.InhibitScroll = False AND SL.Pause=False Then
			SL.SrcRect.Left = SL.SrcRect.Left + 1dip
			SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
			If SL.SrcRect.Right > SL.Bitmap.Width Then
				SL.SrcRect.Left = 0
				SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
				SL.Pause=True
			Else
				If SL.InhibitScroll = False Then repeatDelay = False
			End If
			
			SL.Canvas.DrawRect(SL.DestRect, Colors.Transparent, True, 0)
			SL.Canvas.DrawBitmap(SL.Bitmap, SL.SrcRect, SL.DestRect)
			SL.lbl.Invalidate
		End If
	Next
	If repeatDelay = True Then CallSubDelayed(Main, "ScrollTimer_Pause")
End Sub