﻿Type=StaticCode
Version=3.82
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type Resolution(X As Int, Y As Int)
	Dim vidResolution As Resolution
	Dim vvPath As String
End Sub

Public Sub Load(key As String)
	Dim container As itemContainer
	container.Initialize
	container =	UPNP.browseResults.Get(key)
	' Get the path for the selected video
	vvPath = container.location
	Debug.debugLog("##### SELECTED VIDEO FILE DETAILS  #####" & CRLF & _
				   "      [id         =" & key & "] " & CRLF & _
				   "      [title      =" & container.title & "] " & CRLF & _
				   "      [class      =" & container.itemClass & "]" & CRLF & _
				   "      [resolution =" & container.Resolution & "]" & CRLF & _
				   "      [location   =" & container.location & "]") 'DEBUG
	If vvPath <> "" Then
		' Preferably display video with installed player else use VideoView (limited CODEC support on some devices)
		If VideoPlayerInstalled Then
			' Use installed media player for better CODEC support
			' Allow user to select they're preferred player
			Dim i As Intent
			i.Initialize(i.ACTION_VIEW, vvPath)
			i.SetType("video/rst")
			StartActivity(i)
		Else
			' Use VideoView only .mp4 baseline profile guaranteed to work!
			vidResolution.Initialize
			vidResolution = RegExp.ExtractResolution(container.Resolution)
			StartActivity(Video_View)
		End If
		

	End If
End Sub

Private Sub VideoPlayerInstalled() As Boolean
	' Check for installed apps capable of playing videos
	Dim Packages As PackageManager
	Dim i As Intent
	i.Initialize(i.ACTION_VIEW, "")
	i.SetType("video/*")
	For Each strName As String In Packages.QueryIntentActivities(i)
		' Return True if any of these component names are installed
    	If strName = "me.abitno.vplayer.t/me.abitno.vplayer.VideoActivity" OR _
					 "com.mxtech.videoplayer.ad/.ActivityScreen" Then Return True
	Next
	' Return false if none of the above installed
	Return False
End Sub